'use strict';

var flightModules = require('react-noop-renderer/flight-modules');
var ReactFlightClient = require('react-client/flight');

/**
 * This is a renderer of React that doesn't have a render target output.
 * It is useful to demonstrate the internals of the reconciler in isolation
 * and for testing semantics of reconciliation separate from the host
 * environment.
 */

const _ReactFlightClient = ReactFlightClient({
  supportsBinaryStreams: false,

  resolveModuleReference(idx) {
    return idx;
  },

  preloadModule(idx) {},

  requireModule(idx) {
    return flightModules.readModule(idx);
  },

  parseModel(response, json) {
    return JSON.parse(json, response._fromJSON);
  }

}),
      createResponse = _ReactFlightClient.createResponse,
      processStringChunk = _ReactFlightClient.processStringChunk,
      close = _ReactFlightClient.close;

function read(source) {
  const response = createResponse(source);

  for (let i = 0; i < source.length; i++) {
    processStringChunk(response, source[i], 0);
  }

  close(response);
  return response.readRoot();
}

exports.read = read;
//# sourceMappingURL=react-noop-renderer-flight-client.production.min.js.map
